## diamond-aligner 0.8.35+dfsg

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)
project (DIAMOND)

option(BUILD_STATIC "BUILD_STATIC" OFF)

if(BUILD_STATIC)
    set(CMAKE_FIND_LIBRARY_SUFFIXES ".a")
    set(BUILD_SHARED_LIBRARIES OFF)
    set(CMAKE_EXE_LINKER_FLAGS "-static")
endif()

include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG("-march=native" COMPILER_SUPPORTS_MARCHNATIVE)
if(COMPILER_SUPPORTS_MARCHNATIVE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=native")
endif()

find_package(ZLIB REQUIRED)
find_package(Threads REQUIRED)

set(CMAKE_BUILD_TYPE Release)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wno-uninitialized -Wno-deprecated-declarations -Wno-ignored-attributes -Wno-unused-variable")

include_directories(
  "${CMAKE_SOURCE_DIR}/src"
  "${ZLIB_INCLUDE_DIR}")

add_executable(diamond src/run/main.cpp
  src/basic/config.cpp
  src/util/tinythread.cpp
  src/util/compressed_stream.cpp
  src/basic/score_matrix.cpp
  src/blast/blast_filter.cpp
  src/blast/blast_seg.cpp
  src/blast/sm_blosum45.c
  src/blast/sm_blosum50.c
  src/blast/sm_blosum62.c
  src/blast/sm_blosum80.c
  src/blast/sm_blosum90.c
  src/blast/sm_pam30.c
  src/blast/sm_pam70.c
  src/blast/sm_pam250.c
  src/data/queries.cpp
  src/data/reference.cpp
  src/data/seed_histogram.cpp
  src/output/daa_record.cpp
  src/search/search.cpp
  src/util/command_line_parser.cpp
  src/util/seq_file_format.cpp
  src/util/util.cpp 
  src/util/Timer.cpp
  src/basic/basic.cpp
  src/dp/floating_sw.cpp
  src/basic/hssp.cpp
  src/dp/ungapped_align.cpp
  src/run/tools.cpp
  src/dp/greedy_align.cpp
  src/run/benchmark.cpp
  src/search/stage2.cpp
  src/output/output_format.cpp
  src/output/join_blocks.cpp
  src/run/mapper.cpp
  src/data/count_approximate.cpp
  src/data/index.cpp
  src/data/frequent_seeds.cpp
  src/align/query_mapper.cpp
  src/align/align_target.cpp
  src/output/blast_tab_format.cpp
  src/dp/padded_banded_sw.cpp
  src/dp/needleman_wunsch.cpp
  src/output/blast_pairwise_format.cpp
  src/extra/roc.cpp
  src/dp/comp_based_stats.cpp
  src/extra/model_sim.cpp
  src/run/double_indexed.cpp
  src/search/search_query.cpp
  src/search/collision.cpp
  src/output/sam_format.cpp
  src/align/align.cpp
  src/search/setup.cpp
  src/extra/opt.cpp
)

target_link_libraries(diamond ${ZLIB_LIBRARY} ${CMAKE_THREAD_LIBS_INIT})

install(TARGETS diamond DESTINATION bin)

=== debian/changelog ===
diamond-aligner (0.8.35+dfsg-1) unstable; urgency=medium

  * New upstream version
    Closes: #852752
  * Drop -march=native flag
    Closes: #852753

 -- Andreas Tille <tille@debian.org>  Fri, 03 Feb 2017 21:42:37 +0100

diamond-aligner (0.8.34+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #850242)

 -- Andreas Tille <tille@debian.org>  Thu, 05 Jan 2017 11:51:45 +0100

## diamond-aligner 0.9.8+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -59,9 +59,6 @@
   src/search/stage2.cpp
   src/output/output_format.cpp
   src/output/join_blocks.cpp
-  src/run/mapper.cpp
-  src/data/count_approximate.cpp
-  src/data/index.cpp
   src/data/frequent_seeds.cpp
   src/align/query_mapper.cpp
   src/align/align_target.cpp
@@ -73,12 +70,21 @@
   src/dp/comp_based_stats.cpp
   src/extra/model_sim.cpp
   src/run/double_indexed.cpp
-  src/search/search_query.cpp
   src/search/collision.cpp
   src/output/sam_format.cpp
   src/align/align.cpp
   src/search/setup.cpp
   src/extra/opt.cpp
+  src/dp/diag_scores.cpp
+  src/data/taxonomy.cpp
+  src/lib/tantan/tantan.cc
+  src/basic/masking.cpp
+  src/dp/swipe.cpp
+  src/dp/banded_sw.cpp
+  src/data/sorted_list.cpp
+  src/data/seed_set.cpp
+  src/util/binary_file.cpp
+  src/util/simd.cpp
 )
 
 target_link_libraries(diamond ${ZLIB_LIBRARY} ${CMAKE_THREAD_LIBS_INIT})

=== debian/changelog ===
diamond-aligner (0.9.8+dfsg-1) unstable; urgency=medium

  * New upstream version

 -- Andreas Tille <tille@debian.org>  Mon, 19 Jun 2017 08:15:18 +0200

=== debian/control ===
Source: diamond-aligner
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 10),
               cmake,
               zlib1g-dev
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/diamond-aligner.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/diamond-aligner.git
Homepage: https://github.com/bbuchfink/diamond

Package: diamond-aligner
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: med-config (>= 2.1)
Description: accelerated BLAST compatible local sequence aligner
 DIAMOND is a sequence aligner for protein and translated DNA searches
 and functions as a drop-in replacement for the NCBI BLAST software
 tools. It is suitable for protein-protein search as well as DNA-protein
 search on short reads and longer sequences including contigs and
 assemblies, providing a speedup of BLAST ranging up to x20,000.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export LC_ALL=C.UTF-8

# for hardening you might like to uncomment this:
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

DEBPKGNAME     := $(shell dpkg-parsechangelog | awk '/^Source:/ {print $$2}')

MSSSSE3=$(shell if [ `dpkg-architecture -qDEB_BUILD_ARCH` = 'amd64' ] ; then echo "-mssse3" ; fi)

%:
	dh $@

override_dh_install:
	dh_install
	# due to a file name conflict diamond is moved out of the way
	mkdir -p debian/$(DEBPKGNAME)/usr/lib/debian-med/bin/
	mv debian/$(DEBPKGNAME)/usr/bin/diamond debian/$(DEBPKGNAME)/usr/lib/debian-med/bin/

override_dh_installman:
	dh_installman
	# due to a file name conflict diamond.1 is moved out of the way
	mkdir -p debian/$(DEBPKGNAME)/usr/lib/debian-med/share/man/man1/
	mv debian/$(DEBPKGNAME)/usr/share/man/man1/diamond.1 debian/$(DEBPKGNAME)/usr/lib/debian-med/share/man/man1/
	gzip -9 debian/$(DEBPKGNAME)/usr/lib/debian-med/share/man/man1/diamond.1

override_dh_compress:
	dh_compress --exclude=.pdf

override_dh_fixperms:
	dh_fixperms
	# strangely the manpage becomes executable ... hmmm
	chmod -x debian/$(DEBPKGNAME)/usr/lib/debian-med/share/man/man1/*

build_simple:
	MSSSSE3=$(MSSSSE3) build_simple.sh

## diamond-aligner 0.9.17%2Bdfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -9,10 +9,14 @@
     set(CMAKE_EXE_LINKER_FLAGS "-static")
 endif()
 
-include(CheckCXXCompilerFlag)
-CHECK_CXX_COMPILER_FLAG("-march=native" COMPILER_SUPPORTS_MARCHNATIVE)
-if(COMPILER_SUPPORTS_MARCHNATIVE)
+if(CMAKE_BUILD_MARCH)
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=${CMAKE_BUILD_MARCH}")
+else()
+  include(CheckCXXCompilerFlag)
+  CHECK_CXX_COMPILER_FLAG("-march=native" COMPILER_SUPPORTS_MARCHNATIVE)
+  if(COMPILER_SUPPORTS_MARCHNATIVE)
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=native")
+  endif()
 endif()
 
 find_package(ZLIB REQUIRED)
@@ -50,18 +54,15 @@
   src/util/util.cpp 
   src/util/Timer.cpp
   src/basic/basic.cpp
-  src/dp/floating_sw.cpp
   src/basic/hssp.cpp
   src/dp/ungapped_align.cpp
   src/run/tools.cpp
   src/dp/greedy_align.cpp
-  src/run/benchmark.cpp
   src/search/stage2.cpp
   src/output/output_format.cpp
   src/output/join_blocks.cpp
   src/data/frequent_seeds.cpp
   src/align/query_mapper.cpp
-  src/align/align_target.cpp
   src/output/blast_tab_format.cpp
   src/dp/padded_banded_sw.cpp
   src/dp/needleman_wunsch.cpp
@@ -79,12 +80,21 @@
   src/data/taxonomy.cpp
   src/lib/tantan/tantan.cc
   src/basic/masking.cpp
-  src/dp/swipe.cpp
+  src/dp/swipe/swipe.cpp
   src/dp/banded_sw.cpp
   src/data/sorted_list.cpp
   src/data/seed_set.cpp
   src/util/binary_file.cpp
   src/util/simd.cpp
+  src/output/taxon_format.cpp
+  src/output/view.cpp
+  src/output/output_sink.cpp
+  src/output/target_culling.cpp
+  src/align/greedy_pipeline.cpp
+  src/align/swipe_pipeline.cpp
+  src/dp/swipe/banded_3frame_swipe.cpp
+  src/dp/swipe/banded_swipe.cpp
+  src/align/banded_swipe_pipeline.cpp
 )
 
 target_link_libraries(diamond ${ZLIB_LIBRARY} ${CMAKE_THREAD_LIBS_INIT})

## diamond-aligner 0.9.17+dfsg

=== debian/changelog ===
diamond-aligner (0.9.17+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.1.3
  * debhelper 11

 -- Andreas Tille <tille@debian.org>  Sat, 10 Feb 2018 18:10:44 +0100

diamond-aligner (0.9.10+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Force the symbol with c++ explicit function template instantiation for the
    latter prototype instead of relying on implicit instantiation
  * Standards-Version: 4.1.0 (no changes needed)
  * Do not parse d/changelog

 -- Andreas Tille <tille@debian.org>  Mon, 18 Sep 2017 14:51:21 +0200

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,10 @@
 Uploaders: Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 10),
+Build-Depends: debhelper (>= 11~),
                cmake,
                zlib1g-dev
-Standards-Version: 3.9.8
+Standards-Version: 4.1.3
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/diamond-aligner.git
 Vcs-Git: https://anonscm.debian.org/git/debian-med/diamond-aligner.git
 Homepage: https://github.com/bbuchfink/diamond

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export LC_ALL=C.UTF-8

# for hardening you might like to uncomment this:
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

include /usr/share/dpkg/default.mk

MSSSSE3=$(shell if [ `dpkg-architecture -qDEB_BUILD_ARCH` = 'amd64' ] ; then echo "-mssse3" ; fi)

%:
	dh $@

override_dh_install:
	dh_install
	# due to a file name conflict diamond is moved out of the way
	mkdir -p debian/$(DEB_SOURCE)/usr/lib/debian-med/bin/
	mv debian/$(DEB_SOURCE)/usr/bin/diamond debian/$(DEB_SOURCE)/usr/lib/debian-med/bin/

override_dh_installman:
	dh_installman
	# due to a file name conflict diamond.1 is moved out of the way
	mkdir -p debian/$(DEB_SOURCE)/usr/lib/debian-med/share/man/man1/
	mv debian/$(DEB_SOURCE)/usr/share/man/man1/diamond.1 debian/$(DEB_SOURCE)/usr/lib/debian-med/share/man/man1/
	gzip -9 debian/$(DEB_SOURCE)/usr/lib/debian-med/share/man/man1/diamond.1

override_dh_compress:
	dh_compress --exclude=.pdf

override_dh_fixperms:
	dh_fixperms
	# strangely the manpage becomes executable ... hmmm
	chmod -x debian/$(DEB_SOURCE)/usr/lib/debian-med/share/man/man1/*

build_simple:
	MSSSSE3=$(MSSSSE3) build_simple.sh

## diamond-aligner 0.9.22+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,6 +2,7 @@
 project (DIAMOND)
 
 option(BUILD_STATIC "BUILD_STATIC" OFF)
+option(EXTRA "EXTRA" OFF)
 
 if(BUILD_STATIC)
     set(CMAKE_FIND_LIBRARY_SUFFIXES ".a")
@@ -32,7 +33,6 @@
 add_executable(diamond src/run/main.cpp
   src/basic/config.cpp
   src/util/tinythread.cpp
-  src/util/compressed_stream.cpp
   src/basic/score_matrix.cpp
   src/blast/blast_filter.cpp
   src/blast/blast_seg.cpp
@@ -84,7 +84,6 @@
   src/dp/banded_sw.cpp
   src/data/sorted_list.cpp
   src/data/seed_set.cpp
-  src/util/binary_file.cpp
   src/util/simd.cpp
   src/output/taxon_format.cpp
   src/output/view.cpp
@@ -95,7 +94,36 @@
   src/dp/swipe/banded_3frame_swipe.cpp
   src/dp/swipe/banded_swipe.cpp
   src/align/banded_swipe_pipeline.cpp
+  src/data/ref_dictionary.cpp
+  src/util/io/compressed_stream.cpp
+  src/util/io/deserializer.cpp
+  src/util/io/file_sink.cpp
+  src/util/io/file_source.cpp
+  src/util/io/input_file.cpp
+  src/util/io/input_stream_buffer.cpp
+  src/util/io/output_file.cpp
+  src/util/io/output_stream_buffer.cpp
+  src/util/io/serializer.cpp
+  src/util/io/temp_file.cpp
+  src/util/io/text_input_file.cpp
+  src/data/taxon_list.cpp
+  src/data/taxonomy_nodes.cpp
+  src/util/algo/MurmurHash3.cpp
+  src/search/stage0.cpp
+  src/util/memory/memory_pool.cpp
+  src/data/seed_array.cpp
+  src/output/paf_format.cpp
 )
+
+if(EXTRA)
+  target_sources(diamond
+    PUBLIC
+      src/extra/benchmark.cpp
+	  src/extra/test.cpp
+	  src/dp/sw_3frame.cpp
+  )
+  add_definitions(-DEXTRA)
+endif()
 
 target_link_libraries(diamond ${ZLIB_LIBRARY} ${CMAKE_THREAD_LIBS_INIT})

=== debian/changelog ===
diamond-aligner (0.9.22+dfsg-2~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Andreas Tille <tille@debian.org>  Wed, 17 Oct 2018 13:34:34 +0200

diamond-aligner (0.9.22+dfsg-2) unstable; urgency=medium

  * Do not use march=native flag
    Closes: #906615
  * Standards-Version: 4.2.0

 -- Andreas Tille <tille@debian.org>  Sun, 19 Aug 2018 06:41:39 +0200

diamond-aligner (0.9.22+dfsg-1) unstable; urgency=medium

  * New upstream version

 -- Andreas Tille <tille@debian.org>  Tue, 22 May 2018 15:54:27 +0200

diamond-aligner (0.9.21+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.1.4

 -- Andreas Tille <tille@debian.org>  Thu, 26 Apr 2018 15:10:07 +0200

diamond-aligner (0.9.19+dfsg-1) unstable; urgency=medium

  * New upstream version

 -- Andreas Tille <tille@debian.org>  Thu, 29 Mar 2018 09:37:31 +0200

=== debian/control ===
--- 
+++ 
@@ -6,9 +6,9 @@
 Build-Depends: debhelper (>= 11~),
                cmake,
                zlib1g-dev
-Standards-Version: 4.1.3
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/diamond-aligner.git
-Vcs-Git: https://anonscm.debian.org/git/debian-med/diamond-aligner.git
+Standards-Version: 4.2.0
+Vcs-Browser: https://salsa.debian.org/med-team/diamond-aligner
+Vcs-Git: https://salsa.debian.org/med-team/diamond-aligner.git
 Homepage: https://github.com/bbuchfink/diamond
 
 Package: diamond-aligner

## diamond-aligner 0.9.23+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -9,6 +9,8 @@
     set(BUILD_SHARED_LIBRARIES OFF)
     set(CMAKE_EXE_LINKER_FLAGS "-static")
 endif()
+
+set(CMAKE_CXX_STANDARD 11)
 
 if(CMAKE_BUILD_MARCH)
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=${CMAKE_BUILD_MARCH}")
@@ -24,7 +26,11 @@
 find_package(Threads REQUIRED)
 
 set(CMAKE_BUILD_TYPE Release)
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wno-uninitialized -Wno-deprecated-declarations -Wno-ignored-attributes -Wno-unused-variable")
+if(WIN32)
+  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
+else()
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wno-uninitialized -Wno-ignored-attributes -Wno-unused-variable")
+endif()
 
 include_directories(
   "${CMAKE_SOURCE_DIR}/src"
@@ -113,6 +119,10 @@
   src/util/memory/memory_pool.cpp
   src/data/seed_array.cpp
   src/output/paf_format.cpp
+  src/util/system/system.cpp
+  src/run/cluster.cpp
+  src/util/algo/greedy_vortex_cover.cpp
+  src/util/algo/greedy_vortex_cover_weighted.cpp
 )
 
 if(EXTRA)

=== debian/changelog ===
diamond-aligner (0.9.23+dfsg-2) unstable; urgency=medium

  * Restrict architecture to amd64
    Closes: #916370

 -- Andreas Tille <tille@debian.org>  Thu, 13 Dec 2018 19:52:54 +0100

diamond-aligner (0.9.23+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.2.1

 -- Andreas Tille <tille@debian.org>  Thu, 13 Dec 2018 13:48:51 +0100

## diamond-aligner 0.9.24+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,6 +3,18 @@
 
 option(BUILD_STATIC "BUILD_STATIC" OFF)
 option(EXTRA "EXTRA" OFF)
+option(STATIC_LIBGCC "STATIC_LIBGCC" OFF)
+option(STATIC_LIBSTDC++ "STATIC_LIBSTDC++" OFF)
+option(SSSE3 "SSSE3" OFF)
+option(POPCNT "POPCNT" OFF)
+
+IF(STATIC_LIBSTDC++)
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -static-libstdc++")
+endif()
+
+IF(STATIC_LIBGCC)
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -static-libgcc")
+endif()
 
 if(BUILD_STATIC)
     set(CMAKE_FIND_LIBRARY_SUFFIXES ".a")
@@ -12,7 +24,17 @@
 
 set(CMAKE_CXX_STANDARD 11)
 
-if(CMAKE_BUILD_MARCH)
+if (${CMAKE_CXX_COMPILER_ID} STREQUAL MSVC)
+else()
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++11")
+endif()
+
+if(SSSE3)
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mssse3")
+  if(POPCNT)
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mpopcnt")
+  endif()
+elseif(CMAKE_BUILD_MARCH)
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=${CMAKE_BUILD_MARCH}")
 else()
   include(CheckCXXCompilerFlag)
@@ -123,6 +145,7 @@
   src/run/cluster.cpp
   src/util/algo/greedy_vortex_cover.cpp
   src/util/algo/greedy_vortex_cover_weighted.cpp
+  src/util/sequence/sequence.cpp
 )
 
 if(EXTRA)

=== debian/changelog ===
diamond-aligner (0.9.24+dfsg-1) unstable; urgency=medium

  * New upstream version

 -- Andreas Tille <tille@debian.org>  Sat, 29 Dec 2018 21:10:22 +0100

=== debian/control ===
--- 
+++ 
@@ -6,13 +6,13 @@
 Build-Depends: debhelper (>= 11~),
                cmake,
                zlib1g-dev
-Standards-Version: 4.2.0
+Standards-Version: 4.2.1
 Vcs-Browser: https://salsa.debian.org/med-team/diamond-aligner
 Vcs-Git: https://salsa.debian.org/med-team/diamond-aligner.git
 Homepage: https://github.com/bbuchfink/diamond
 
 Package: diamond-aligner
-Architecture: any
+Architecture: amd64
 Depends: ${shlibs:Depends},
          ${misc:Depends}
 Recommends: med-config (>= 2.1)

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,repack,compression=xz" \
   https://github.com/bbuchfink/diamond/releases .*/archive/v(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## diamond-aligner 0.9.25+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -47,7 +47,10 @@
 find_package(ZLIB REQUIRED)
 find_package(Threads REQUIRED)
 
-set(CMAKE_BUILD_TYPE Release)
+if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
+  set(CMAKE_BUILD_TYPE Release)
+endif()
+
 if(WIN32)
   add_definitions(-D_CRT_SECURE_NO_WARNINGS)
 else()
@@ -60,7 +63,6 @@
 
 add_executable(diamond src/run/main.cpp
   src/basic/config.cpp
-  src/util/tinythread.cpp
   src/basic/score_matrix.cpp
   src/blast/blast_filter.cpp
   src/blast/blast_seg.cpp
@@ -95,15 +97,12 @@
   src/dp/padded_banded_sw.cpp
   src/dp/needleman_wunsch.cpp
   src/output/blast_pairwise_format.cpp
-  src/extra/roc.cpp
   src/dp/comp_based_stats.cpp
-  src/extra/model_sim.cpp
   src/run/double_indexed.cpp
   src/search/collision.cpp
   src/output/sam_format.cpp
   src/align/align.cpp
   src/search/setup.cpp
-  src/extra/opt.cpp
   src/dp/diag_scores.cpp
   src/data/taxonomy.cpp
   src/lib/tantan/tantan.cc
@@ -146,6 +145,10 @@
   src/util/algo/greedy_vortex_cover.cpp
   src/util/algo/greedy_vortex_cover_weighted.cpp
   src/util/sequence/sequence.cpp
+  src/tools/tsv_record.cpp
+  src/tools/tools.cpp
+  src/util/system/getRSS.cpp
+  src/util/math/sparse_matrix.cpp
 )
 
 if(EXTRA)
@@ -154,6 +157,9 @@
       src/extra/benchmark.cpp
 	  src/extra/test.cpp
 	  src/dp/sw_3frame.cpp
+	  src/extra/roc.cpp
+	  src/extra/model_sim.cpp
+	  src/extra/opt.cpp
   )
   add_definitions(-DEXTRA)
 endif()

=== debian/changelog ===
diamond-aligner (0.9.25+dfsg-1) unstable; urgency=medium

  * New upstream version
  * debhelper-compat 12
  * Standards-Version: 4.4.0
  * Drop unneeded paragraph from d/copyright

 -- Andreas Tille <tille@debian.org>  Thu, 01 Aug 2019 15:00:33 +0200

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,10 @@
 Uploaders: Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 11~),
+Build-Depends: debhelper-compat (= 12),
                cmake,
                zlib1g-dev
-Standards-Version: 4.2.1
+Standards-Version: 4.4.0
 Vcs-Browser: https://salsa.debian.org/med-team/diamond-aligner
 Vcs-Git: https://salsa.debian.org/med-team/diamond-aligner.git
 Homepage: https://github.com/bbuchfink/diamond

## diamond-aligner 0.9.29+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,8 +5,6 @@
 option(EXTRA "EXTRA" OFF)
 option(STATIC_LIBGCC "STATIC_LIBGCC" OFF)
 option(STATIC_LIBSTDC++ "STATIC_LIBSTDC++" OFF)
-option(SSSE3 "SSSE3" OFF)
-option(POPCNT "POPCNT" OFF)
 
 IF(STATIC_LIBSTDC++)
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -static-libstdc++")
@@ -29,19 +27,8 @@
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++11")
 endif()
 
-if(SSSE3)
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mssse3")
-  if(POPCNT)
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mpopcnt")
-  endif()
-elseif(CMAKE_BUILD_MARCH)
+if(CMAKE_BUILD_MARCH)
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=${CMAKE_BUILD_MARCH}")
-else()
-  include(CheckCXXCompilerFlag)
-  CHECK_CXX_COMPILER_FLAG("-march=native" COMPILER_SUPPORTS_MARCHNATIVE)
-  if(COMPILER_SUPPORTS_MARCHNATIVE)
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=native")
-  endif()
 endif()
 
 find_package(ZLIB REQUIRED)
@@ -52,7 +39,7 @@
 endif()
 
 if(WIN32)
-  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
+  add_definitions(-D_CRT_SECURE_NO_WARNINGS -D_ITERATOR_DEBUG_LEVEL=0)
 else()
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wno-uninitialized -Wno-ignored-attributes -Wno-unused-variable")
 endif()
@@ -61,7 +48,25 @@
   "${CMAKE_SOURCE_DIR}/src"
   "${ZLIB_INCLUDE_DIR}")
 
-add_executable(diamond src/run/main.cpp
+set(DISPATCH_OBJECTS
+"src/dp/swipe/banded_3frame_swipe.cpp"
+"src/dp/swipe/swipe.cpp"
+"src/dp/swipe/banded_swipe.cpp"
+"src/search/collision.cpp"
+"src/search/stage1.cpp"
+"src/search/stage2.cpp"
+"src/tools/benchmark.cpp"
+"src/dp/swipe/swipe_wrapper.cpp"
+)
+
+add_library(arch_generic OBJECT ${DISPATCH_OBJECTS})
+target_compile_options(arch_generic PUBLIC -DDISPATCH_ARCH=ARCH_GENERIC)
+add_library(arch_sse4_1 OBJECT ${DISPATCH_OBJECTS})
+target_compile_options(arch_sse4_1 PUBLIC -DDISPATCH_ARCH=ARCH_SSE4_1 -mssse3 -mpopcnt -msse4.1)
+
+add_executable(diamond $<TARGET_OBJECTS:arch_generic>
+  $<TARGET_OBJECTS:arch_sse4_1>
+  src/run/main.cpp
   src/basic/config.cpp
   src/basic/score_matrix.cpp
   src/blast/blast_filter.cpp
@@ -78,7 +83,6 @@
   src/data/reference.cpp
   src/data/seed_histogram.cpp
   src/output/daa_record.cpp
-  src/search/search.cpp
   src/util/command_line_parser.cpp
   src/util/seq_file_format.cpp
   src/util/util.cpp 
@@ -88,7 +92,6 @@
   src/dp/ungapped_align.cpp
   src/run/tools.cpp
   src/dp/greedy_align.cpp
-  src/search/stage2.cpp
   src/output/output_format.cpp
   src/output/join_blocks.cpp
   src/data/frequent_seeds.cpp
@@ -99,7 +102,6 @@
   src/output/blast_pairwise_format.cpp
   src/dp/comp_based_stats.cpp
   src/run/double_indexed.cpp
-  src/search/collision.cpp
   src/output/sam_format.cpp
   src/align/align.cpp
   src/search/setup.cpp
@@ -107,9 +109,7 @@
   src/data/taxonomy.cpp
   src/lib/tantan/tantan.cc
   src/basic/masking.cpp
-  src/dp/swipe/swipe.cpp
   src/dp/banded_sw.cpp
-  src/data/sorted_list.cpp
   src/data/seed_set.cpp
   src/util/simd.cpp
   src/output/taxon_format.cpp
@@ -118,8 +118,6 @@
   src/output/target_culling.cpp
   src/align/greedy_pipeline.cpp
   src/align/swipe_pipeline.cpp
-  src/dp/swipe/banded_3frame_swipe.cpp
-  src/dp/swipe/banded_swipe.cpp
   src/align/banded_swipe_pipeline.cpp
   src/data/ref_dictionary.cpp
   src/util/io/compressed_stream.cpp
@@ -137,7 +135,6 @@
   src/data/taxonomy_nodes.cpp
   src/util/algo/MurmurHash3.cpp
   src/search/stage0.cpp
-  src/util/memory/memory_pool.cpp
   src/data/seed_array.cpp
   src/output/paf_format.cpp
   src/util/system/system.cpp
@@ -149,6 +146,8 @@
   src/tools/tools.cpp
   src/util/system/getRSS.cpp
   src/util/math/sparse_matrix.cpp
+  src/lib/tantan/LambdaCalculator.cc
+  src/data/taxonomy_filter.cpp
 )
 
 if(EXTRA)

=== debian/changelog ===
diamond-aligner (0.9.29+dfsg-5) unstable; urgency=medium

  * Team upload.
  * Restrict the use of the gold linker on architectures where it is not
    available.

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Tue, 14 Jan 2020 08:54:46 +0100

diamond-aligner (0.9.29+dfsg-4) unstable; urgency=medium

  * Breaks+Replaces: diamond
    Closes: #948849

 -- Andreas Tille <tille@debian.org>  Tue, 14 Jan 2020 08:03:08 +0100

diamond-aligner (0.9.29+dfsg-3) unstable; urgency=medium

  * Team upload.
  * patch to enable non-x86 builds again (no -msse, etc..)
    Closes: #942850

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Mon, 13 Jan 2020 19:34:04 +0100

diamond-aligner (0.9.29+dfsg-2) unstable; urgency=medium

  [ Frédéric Bonnard ]
  * Upstream 0.9.29 includes patch to build diamond-aligner on any
    Closes: #942850

  [ Andreas Tille ]
  * Package diamond was removed from Debian so the name /usr/bin/diamond
    can be used again
  * Set upstream metadata fields: Bug-Database, Bug-Submit.

 -- Andreas Tille <tille@debian.org>  Fri, 10 Jan 2020 13:50:28 +0100

diamond-aligner (0.9.29+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version

 -- Steffen Moeller <moeller@debian.org>  Thu, 05 Dec 2019 00:17:29 +0100

diamond-aligner (0.9.28+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * One patch against upstream could go (-mnative no longer set)

 -- Steffen Moeller <moeller@debian.org>  Fri, 08 Nov 2019 19:28:00 +0100

diamond-aligner (0.9.26+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version

 -- Steffen Moeller <moeller@debian.org>  Fri, 20 Sep 2019 00:20:39 +0200

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export LC_ALL=C.UTF-8

# for hardening you might like to uncomment this:
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

include /usr/share/dpkg/default.mk

# Use the gold linker where we can
ifeq (,$(filter $(DEB_HOST_ARCH),hppa ia64 m68k riscv64 sh4))
export LD=ld.gold
export DEB_CFLAGS_MAINT_APPEND+=-fuse-ld=gold
export DEB_CXXFLAGS_MAINT_APPEND+=-fuse-ld=gold
endif

ifeq (,$(filter $(DEB_HOST_ARCH),amd64 i386))
	EXTRA=-DX86=OFF
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(EXTRA)

override_dh_compress:
	dh_compress --exclude=.pdf

## diamond-aligner 0.9.30

=== CMakeLists.txt ===
--- 
+++ 
@@ -46,7 +46,8 @@
 
 include_directories(
   "${CMAKE_SOURCE_DIR}/src"
-  "${ZLIB_INCLUDE_DIR}")
+  "${ZLIB_INCLUDE_DIR}"
+  "${CMAKE_SOURCE_DIR}/src/lib")
 
 set(DISPATCH_OBJECTS
 "src/dp/swipe/banded_3frame_swipe.cpp"
@@ -57,6 +58,7 @@
 "src/search/stage2.cpp"
 "src/tools/benchmark.cpp"
 "src/dp/swipe/swipe_wrapper.cpp"
+"src/util/tantan.cpp"
 )
 
 add_library(arch_generic OBJECT ${DISPATCH_OBJECTS})
@@ -86,7 +88,6 @@
   src/util/command_line_parser.cpp
   src/util/seq_file_format.cpp
   src/util/util.cpp 
-  src/util/Timer.cpp
   src/basic/basic.cpp
   src/basic/hssp.cpp
   src/dp/ungapped_align.cpp
@@ -95,7 +96,7 @@
   src/output/output_format.cpp
   src/output/join_blocks.cpp
   src/data/frequent_seeds.cpp
-  src/align/query_mapper.cpp
+  src/align/legacy/query_mapper.cpp
   src/output/blast_tab_format.cpp
   src/dp/padded_banded_sw.cpp
   src/dp/needleman_wunsch.cpp
@@ -107,7 +108,6 @@
   src/search/setup.cpp
   src/dp/diag_scores.cpp
   src/data/taxonomy.cpp
-  src/lib/tantan/tantan.cc
   src/basic/masking.cpp
   src/dp/banded_sw.cpp
   src/data/seed_set.cpp
@@ -116,9 +116,9 @@
   src/output/view.cpp
   src/output/output_sink.cpp
   src/output/target_culling.cpp
-  src/align/greedy_pipeline.cpp
-  src/align/swipe_pipeline.cpp
-  src/align/banded_swipe_pipeline.cpp
+  src/align/legacy/greedy_pipeline.cpp
+  src/align/legacy/swipe_pipeline.cpp
+  src/align/legacy/banded_swipe_pipeline.cpp
   src/data/ref_dictionary.cpp
   src/util/io/compressed_stream.cpp
   src/util/io/deserializer.cpp
@@ -140,7 +140,6 @@
   src/util/system/system.cpp
   src/run/cluster.cpp
   src/util/algo/greedy_vortex_cover.cpp
-  src/util/algo/greedy_vortex_cover_weighted.cpp
   src/util/sequence/sequence.cpp
   src/tools/tsv_record.cpp
   src/tools/tools.cpp
@@ -148,6 +147,21 @@
   src/util/math/sparse_matrix.cpp
   src/lib/tantan/LambdaCalculator.cc
   src/data/taxonomy_filter.cpp
+  src/util/algo/upgma.cpp
+  src/util/algo/upgma_mc.cpp
+  src/util/algo/edge_vec.cpp
+  src/util/string/string.cpp
+  src/align/extend.cpp
+  src/align/target.cpp
+  src/test/simulate.cpp
+  src/test/test.cpp
+  src/align/ranking.cpp
+  src/align/ungapped.cpp
+  src/align/gapped.cpp
+  src/align/culling.cpp
+  src/cluster/medoid.cpp
+  src/align/output.cpp
+  src/tools/roc.cpp
 )
 
 if(EXTRA)

=== debian/changelog ===
diamond-aligner (0.9.30-3) unstable; urgency=medium

  * Team upload.
  * Patch from upstream to fix i386 & s390x builds

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Mon, 17 Feb 2020 14:22:48 +0100

diamond-aligner (0.9.30-2) unstable; urgency=medium

  * Team upload.
  * No ld.gold for alpha

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Thu, 06 Feb 2020 15:41:48 +0100

diamond-aligner (0.9.30-1) unstable; urgency=medium

  * Team upload.
  * New upstream version

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Wed, 05 Feb 2020 14:04:34 +0100

=== debian/control ===
--- 
+++ 
@@ -6,16 +6,18 @@
 Build-Depends: debhelper-compat (= 12),
                cmake,
                zlib1g-dev
-Standards-Version: 4.4.0
+Standards-Version: 4.4.1
 Vcs-Browser: https://salsa.debian.org/med-team/diamond-aligner
 Vcs-Git: https://salsa.debian.org/med-team/diamond-aligner.git
 Homepage: https://github.com/bbuchfink/diamond
 
 Package: diamond-aligner
-Architecture: amd64
+Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends}
 Recommends: med-config (>= 2.1)
+Breaks: diamond
+Replaces: diamond
 Description: accelerated BLAST compatible local sequence aligner
  DIAMOND is a sequence aligner for protein and translated DNA searches
  and functions as a drop-in replacement for the NCBI BLAST software

=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,7 @@
 include /usr/share/dpkg/default.mk
 
 # Use the gold linker where we can
-ifeq (,$(filter $(DEB_HOST_ARCH),hppa ia64 m68k riscv64 sh4))
+ifeq (,$(filter $(DEB_HOST_ARCH),alpha hppa ia64 m68k riscv64 sh4))
 export LD=ld.gold
 export DEB_CFLAGS_MAINT_APPEND+=-fuse-ld=gold
 export DEB_CXXFLAGS_MAINT_APPEND+=-fuse-ld=gold

## diamond-aligner 2.0.4

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)
project (DIAMOND)

option(BUILD_STATIC "BUILD_STATIC" OFF)
option(EXTRA "EXTRA" OFF)
option(STATIC_LIBGCC "STATIC_LIBGCC" OFF)
option(STATIC_LIBSTDC++ "STATIC_LIBSTDC++" OFF)
option(X86 "X86" ON)
option(STRICT_BAND "STRICT_BAND" ON)
option(LEFTMOST_SEED_FILTER "LEFTMOST_SEED_FILTER" ON)
option(SEQ_MASK "SEQ_MASK" ON)
option(DP_STAT "DP_STAT" OFF)
set(MAX_SHAPE_LEN 19)

if(CMAKE_SYSTEM_PROCESSOR MATCHES "^(arm.*|ARM.*)")
  set(X86 OFF)
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "^(aarch64.*|AARCH64.*)")
  set(X86 OFF)
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "PPC64*|ppc64*|powerpc64*")
  set(X86 OFF)
  # set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -maltivec")
  add_definitions(-DEIGEN_DONT_VECTORIZE)
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "^s390")
  set(X86 OFF)
endif()

if(STATIC_LIBSTDC++)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -static-libstdc++")
endif()

if(STRICT_BAND)
  add_definitions(-DSTRICT_BAND)
endif()

if(SEQ_MASK)
  add_definitions(-DSEQ_MASK)
endif()

if(LEFTMOST_SEED_FILTER)
  add_definitions(-DLEFTMOST_SEED_FILTER)
endif()

if(DP_STAT)
  add_definitions(-DDP_STAT)
endif()

add_definitions(-DMAX_SHAPE_LEN=${MAX_SHAPE_LEN})

IF(STATIC_LIBGCC)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -static-libgcc")
endif()

if(BUILD_STATIC)
    set(CMAKE_FIND_LIBRARY_SUFFIXES ".a")
    set(BUILD_SHARED_LIBRARIES OFF)
    set(CMAKE_EXE_LINKER_FLAGS "-static")
endif()

set(CMAKE_CXX_STANDARD 11)

if(CMAKE_BUILD_MARCH)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=${CMAKE_BUILD_MARCH}")
endif()

find_package(ZLIB REQUIRED)
find_package(Threads REQUIRED)

if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(CMAKE_BUILD_TYPE Release)
endif()

if (${CMAKE_CXX_COMPILER_ID} STREQUAL MSVC)
  add_definitions(-D_CRT_SECURE_NO_WARNINGS -D_ITERATOR_DEBUG_LEVEL=0)
else()
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++11 -Wall -Wextra -Wno-implicit-fallthrough -Wreturn-type -Wno-unused -Wno-unused-parameter -Wno-unused-variable -Wno-uninitialized -Wno-deprecated-copy -Wno-unknown-warning-option")
  # -fsanitize=address -fno-omit-frame-pointer
endif()

if (CMAKE_COMPILER_IS_GNUCC AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 5)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fabi-version=7")
  message("Setting -fabi-version for GCC 4.x")
endif()

include_directories(
  "${ZLIB_INCLUDE_DIR}"
  "${CMAKE_SOURCE_DIR}/src/lib")

set(DISPATCH_OBJECTS
"src/dp/swipe/banded_3frame_swipe.cpp"
"src/dp/swipe/swipe.cpp"
"src/dp/swipe/banded_swipe.cpp"
"src/search/collision.cpp"
"src/search/stage1.cpp"
"src/search/stage2.cpp"
"src/tools/benchmark.cpp"
"src/dp/swipe/swipe_wrapper.cpp"
"src/util/tantan.cpp"
"src/dp/scan_diags.cpp"
"src/dp/ungapped_simd.cpp"
)

add_library(arch_generic OBJECT ${DISPATCH_OBJECTS})
target_compile_options(arch_generic PUBLIC -DDISPATCH_ARCH=ARCH_GENERIC -DARCH_ID=0 -DEigen=Eigen_GENERIC)
if(X86)
add_library(arch_sse4_1 OBJECT ${DISPATCH_OBJECTS})
add_library(arch_avx2 OBJECT ${DISPATCH_OBJECTS})
if (${CMAKE_CXX_COMPILER_ID} STREQUAL MSVC)
	target_compile_options(arch_sse4_1 PUBLIC -DDISPATCH_ARCH=ARCH_SSE4_1 -DARCH_ID=1 -D__SSSE3__ -D__SSE4_1__ -D__POPCNT__ -DEigen=Eigen_SSE4_1)
    target_compile_options(arch_avx2 PUBLIC -DDISPATCH_ARCH=ARCH_AVX2 -DARCH_ID=2 /arch:AVX2 -D__SSSE3__ -D__SSE4_1__ -D__POPCNT__ -DEigen=Eigen_AVX2)
else()
	target_compile_options(arch_sse4_1 PUBLIC -DDISPATCH_ARCH=ARCH_SSE4_1 -DARCH_ID=1 -mssse3 -mpopcnt -msse4.1 -DEigen=Eigen_SSE4_1)
    target_compile_options(arch_avx2 PUBLIC -DDISPATCH_ARCH=ARCH_AVX2 -DARCH_ID=2 -mssse3 -mpopcnt -msse4.1 -msse4.2 -mavx -mavx2 -DEigen=Eigen_AVX2)
endif()
endif(X86)

set(OBJECTS
  src/run/main.cpp
  src/basic/config.cpp
  src/basic/score_matrix.cpp
  src/data/queries.cpp
  src/data/reference.cpp
  src/data/seed_histogram.cpp
  src/output/daa_record.cpp
  src/util/command_line_parser.cpp
  src/util/seq_file_format.cpp
  src/util/util.cpp
  src/basic/basic.cpp
  src/basic/hssp.cpp
  src/dp/ungapped_align.cpp
  src/run/tools.cpp
  src/chaining/greedy_align.cpp
  src/output/output_format.cpp
  src/output/clustering_variables.cpp
  src/output/clustering_format.cpp
  src/output/join_blocks.cpp
  src/data/frequent_seeds.cpp
  src/align/legacy/query_mapper.cpp
  src/output/blast_tab_format.cpp
  src/dp/needleman_wunsch.cpp
  src/output/blast_pairwise_format.cpp
  src/dp/comp_based_stats.cpp
  src/run/double_indexed.cpp
  src/output/sam_format.cpp
  src/align/align.cpp
  src/search/setup.cpp
  src/data/taxonomy.cpp
  src/basic/masking.cpp
  src/dp/banded_sw.cpp
  src/data/seed_set.cpp
  src/util/simd.cpp
  src/output/taxon_format.cpp
  src/output/view.cpp
  src/output/output_sink.cpp
  src/output/target_culling.cpp
  src/align/legacy/swipe_pipeline.cpp
  src/align/legacy/banded_swipe_pipeline.cpp
  src/data/ref_dictionary.cpp
  src/util/io/compressed_stream.cpp
  src/util/io/deserializer.cpp
  src/util/io/file_sink.cpp
  src/util/io/file_source.cpp
  src/util/io/input_file.cpp
  src/util/io/input_stream_buffer.cpp
  src/util/io/output_file.cpp
  src/util/io/output_stream_buffer.cpp
  src/util/io/serializer.cpp
  src/util/io/temp_file.cpp
  src/util/io/text_input_file.cpp
  src/data/taxon_list.cpp
  src/data/taxonomy_nodes.cpp
  src/util/algo/MurmurHash3.cpp
  src/search/stage0.cpp
  src/data/seed_array.cpp
  src/output/paf_format.cpp
  src/util/system/system.cpp
  src/util/algo/greedy_vortex_cover.cpp
  src/util/sequence/sequence.cpp
  src/tools/tsv_record.cpp
  src/tools/tools.cpp
  src/util/system/getRSS.cpp
  src/util/math/sparse_matrix.cpp
  src/lib/tantan/LambdaCalculator.cc
  src/data/taxonomy_filter.cpp
  src/util/algo/upgma.cpp
  src/util/algo/upgma_mc.cpp
  src/util/algo/edge_vec.cpp
  src/util/string/string.cpp
  src/align/extend.cpp
  src/test/simulate.cpp
  src/test/test.cpp
  src/align/ranking.cpp
  src/align/ungapped.cpp
  src/align/gapped.cpp
  src/align/culling.cpp
  src/cluster/medoid.cpp
  src/cluster/cluster_registry.cpp
  src/cluster/multi_step_cluster.cpp
  src/cluster/mcl.cpp
  src/align/output.cpp
  src/tools/roc.cpp
  src/test/data.cpp
  src/basic/matrix_tables.cpp
  src/test/test_cases.cpp
  src/chaining/smith_waterman.cpp
  src/basic/value.cpp
  src/tools/merge_tsv.cpp
  src/output/xml_format.cpp
  src/align/gapped_filter.cpp
  src/util/parallel/filestack.cpp
  src/util/parallel/parallelizer.cpp
  src/util/parallel/multiprocessing.cpp
  src/tools/benchmark_io.cpp
  src/align/memory.cpp
)

if(X86)
  add_executable(diamond $<TARGET_OBJECTS:arch_avx2>
    $<TARGET_OBJECTS:arch_sse4_1>
    $<TARGET_OBJECTS:arch_generic>
    ${OBJECTS}
  )
else()
add_executable(diamond $<TARGET_OBJECTS:arch_generic>
  ${OBJECTS}
)
endif()

target_link_libraries(diamond ${ZLIB_LIBRARY} ${CMAKE_THREAD_LIBS_INIT})

install(TARGETS diamond DESTINATION bin)

=== debian/changelog ===
diamond-aligner (2.0.4-2) unstable; urgency=medium

  * Team upload.
  * Remove mips64el from the arch list, it is not supported upstream

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 31 Aug 2020 16:12:52 +0200

diamond-aligner (2.0.4-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Added patch to fix some typos and minor grammatical errors
  * Fix cross-building with test invocation

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 31 Aug 2020 15:03:46 +0200

diamond-aligner (2.0.2-1) unstable; urgency=medium

  * New upstream version

 -- Andreas Tille <tille@debian.org>  Mon, 10 Aug 2020 23:37:19 +0200

diamond-aligner (0.9.35-1) unstable; urgency=medium

  * Run test suite verbosely (no --quiet option)
  * New upstream version

 -- Andreas Tille <tille@debian.org>  Sat, 20 Jun 2020 15:44:31 +0200

diamond-aligner (0.9.33-1) unstable; urgency=medium

  * New upstream version
    Closes: #959374
  * Remove sh4 from architecture list
    Closes: #959373
  * debhelper-compat 13 (routine-update)

 -- Andreas Tille <tille@debian.org>  Tue, 02 Jun 2020 11:06:15 +0200

diamond-aligner (0.9.32-2) unstable; urgency=medium

  * Fixed different build issues
    Closes: #958515, #958090
  * Upstream says diamond-aligner does not run on 32bit systems
    https://github.com/bbuchfink/diamond/issues/347#issuecomment-622051316

 -- Andreas Tille <tille@debian.org>  Thu, 30 Apr 2020 21:43:33 +0200

diamond-aligner (0.9.32-1) unstable; urgency=medium

  * New upstream version

 -- Andreas Tille <tille@debian.org>  Wed, 29 Apr 2020 12:43:07 +0200

diamond-aligner (0.9.31-2) unstable; urgency=medium

  * Use test from proteinorto as build time and autopkgtest

 -- Andreas Tille <tille@debian.org>  Tue, 28 Apr 2020 19:10:26 +0200

diamond-aligner (0.9.31-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.5.0 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Repository, Repository-Browse.

 -- Andreas Tille <tille@debian.org>  Fri, 27 Mar 2020 16:13:46 +0100

=== debian/control ===
--- 
+++ 
@@ -3,16 +3,17 @@
 Uploaders: Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                cmake,
                zlib1g-dev
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/med-team/diamond-aligner
 Vcs-Git: https://salsa.debian.org/med-team/diamond-aligner.git
 Homepage: https://github.com/bbuchfink/diamond
+Rules-Requires-Root: no
 
 Package: diamond-aligner
-Architecture: any
+Architecture: any-amd64 arm64 ppc64el s390x ia64 ppc64 riscv64 sparc64
 Depends: ${shlibs:Depends},
          ${misc:Depends}
 Recommends: med-config (>= 2.1)

## diamond-aligner 2.0.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -152,7 +152,6 @@
   src/output/view.cpp
   src/output/output_sink.cpp
   src/output/target_culling.cpp
-  src/align/legacy/swipe_pipeline.cpp
   src/align/legacy/banded_swipe_pipeline.cpp
   src/data/ref_dictionary.cpp
   src/util/io/compressed_stream.cpp
@@ -211,6 +210,26 @@
   src/util/parallel/multiprocessing.cpp
   src/tools/benchmark_io.cpp
   src/align/memory.cpp
+  src/lib/alp/njn_dynprogprob.cpp
+  src/lib/alp/njn_dynprogproblim.cpp
+  src/lib/alp/njn_dynprogprobproto.cpp
+  src/lib/alp/njn_ioutil.cpp
+  src/lib/alp/njn_localmaxstat.cpp
+  src/lib/alp/njn_localmaxstatmatrix.cpp
+  src/lib/alp/njn_localmaxstatutil.cpp
+  src/lib/alp/njn_random.cpp
+  src/lib/alp/sls_alignment_evaluer.cpp
+  src/lib/alp/sls_alp.cpp
+  src/lib/alp/sls_alp_data.cpp
+  src/lib/alp/sls_alp_regression.cpp
+  src/lib/alp/sls_alp_sim.cpp
+  src/lib/alp/sls_basic.cpp
+  src/lib/alp/sls_pvalues.cpp
+  src/align/global_ranking/global_ranking.cpp
+  src/align/global_ranking/extend.cpp
+  src/align/load_hits.cpp
+  src/tools/rocid.cpp
+  src/basic/cbs.cpp
 )
 
 if(X86)

=== debian/changelog ===
diamond-aligner (2.0.5-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Spelling patch removed, it was merged upstream.

 -- Michael R. Crusoe <crusoe@debian.org>  Sat, 21 Nov 2020 19:56:55 +0100

## diamond-aligner 2.0.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -44,6 +44,10 @@
   add_definitions(-DDP_STAT)
 endif()
 
+if(EXTRA)
+  add_definitions(-DEXTRA)
+endif()
+
 add_definitions(-DMAX_SHAPE_LEN=${MAX_SHAPE_LEN})
 
 IF(STATIC_LIBGCC)
@@ -74,6 +78,10 @@
 else()
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++11 -Wall -Wextra -Wno-implicit-fallthrough -Wreturn-type -Wno-unused -Wno-unused-parameter -Wno-unused-variable -Wno-uninitialized -Wno-deprecated-copy -Wno-unknown-warning-option")
   # -fsanitize=address -fno-omit-frame-pointer
+endif()
+
+if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-pragma-clang-attribute -Wno-overloaded-virtual -Wno-missing-braces")
 endif()
 
 if (CMAKE_COMPILER_IS_GNUCC AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 5)
@@ -116,7 +124,7 @@
 set(OBJECTS
   src/run/main.cpp
   src/basic/config.cpp
-  src/basic/score_matrix.cpp
+  src/stats/score_matrix.cpp
   src/data/queries.cpp
   src/data/reference.cpp
   src/data/seed_histogram.cpp
@@ -138,7 +146,6 @@
   src/output/blast_tab_format.cpp
   src/dp/needleman_wunsch.cpp
   src/output/blast_pairwise_format.cpp
-  src/dp/comp_based_stats.cpp
   src/run/double_indexed.cpp
   src/output/sam_format.cpp
   src/align/align.cpp
@@ -187,7 +194,6 @@
   src/align/extend.cpp
   src/test/simulate.cpp
   src/test/test.cpp
-  src/align/ranking.cpp
   src/align/ungapped.cpp
   src/align/gapped.cpp
   src/align/culling.cpp
@@ -198,7 +204,6 @@
   src/align/output.cpp
   src/tools/roc.cpp
   src/test/data.cpp
-  src/basic/matrix_tables.cpp
   src/test/test_cases.cpp
   src/chaining/smith_waterman.cpp
   src/basic/value.cpp
@@ -229,19 +234,28 @@
   src/align/global_ranking/extend.cpp
   src/align/load_hits.cpp
   src/tools/rocid.cpp
-  src/basic/cbs.cpp
+  src/lib/blast/blast_seg.cpp
+  src/lib/blast/blast_filter.cpp
+  src/lib/blast/nlm_linear_algebra.cpp
+  src/stats/matrices/blosum45.cpp
+  src/stats/matrices/blosum50.cpp
+  src/stats/matrices/blosum62.cpp
+  src/stats/matrices/blosum80.cpp
+  src/stats/matrices/blosum90.cpp
+  src/stats/matrices/pam250.cpp
+  src/stats/matrices/pam30.cpp
+  src/stats/matrices/pam70.cpp
+  src/stats/stats.cpp
+  src/stats/cbs.cpp
+  src/stats/comp_based_stats.cpp
+  src/stats/hauser_correction.cpp
+  src/stats/matrix_adjust.cpp
 )
 
 if(X86)
-  add_executable(diamond $<TARGET_OBJECTS:arch_avx2>
-    $<TARGET_OBJECTS:arch_sse4_1>
-    $<TARGET_OBJECTS:arch_generic>
-    ${OBJECTS}
-  )
+  add_executable(diamond $<TARGET_OBJECTS:arch_generic> $<TARGET_OBJECTS:arch_sse4_1> $<TARGET_OBJECTS:arch_avx2> ${OBJECTS})
 else()
-add_executable(diamond $<TARGET_OBJECTS:arch_generic>
-  ${OBJECTS}
-)
+  add_executable(diamond $<TARGET_OBJECTS:arch_generic> ${OBJECTS})
 endif()
 
 target_link_libraries(diamond ${ZLIB_LIBRARY} ${CMAKE_THREAD_LIBS_INIT})

=== debian/changelog ===
diamond-aligner (2.0.6-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Standards-Version: 4.5.1 (routine-update)

 -- Michael R. Crusoe <crusoe@debian.org>  Sun, 03 Jan 2021 14:45:31 +0100

## diamond-aligner 2.0.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -10,6 +10,8 @@
 option(LEFTMOST_SEED_FILTER "LEFTMOST_SEED_FILTER" ON)
 option(SEQ_MASK "SEQ_MASK" ON)
 option(DP_STAT "DP_STAT" OFF)
+option(SINGLE_THREADED "SINGLE_THREADED" OFF)
+option(EIGEN_BLAS "EIGEN_BLAS" OFF)
 set(MAX_SHAPE_LEN 19)
 
 if(CMAKE_SYSTEM_PROCESSOR MATCHES "^(arm.*|ARM.*)")
@@ -30,6 +32,10 @@
 
 if(STRICT_BAND)
   add_definitions(-DSTRICT_BAND)
+endif()
+
+if(SINGLE_THREADED)
+  add_definitions(-DSINGLE_THREADED)
 endif()
 
 if(SEQ_MASK)
@@ -89,15 +95,10 @@
   message("Setting -fabi-version for GCC 4.x")
 endif()
 
-include_directories(
-  "${ZLIB_INCLUDE_DIR}"
-  "${CMAKE_SOURCE_DIR}/src/lib")
-
 set(DISPATCH_OBJECTS
 "src/dp/swipe/banded_3frame_swipe.cpp"
 "src/dp/swipe/swipe.cpp"
 "src/dp/swipe/banded_swipe.cpp"
-"src/search/collision.cpp"
 "src/search/stage1.cpp"
 "src/search/stage2.cpp"
 "src/tools/benchmark.cpp"
@@ -109,9 +110,12 @@
 
 add_library(arch_generic OBJECT ${DISPATCH_OBJECTS})
 target_compile_options(arch_generic PUBLIC -DDISPATCH_ARCH=ARCH_GENERIC -DARCH_ID=0 -DEigen=Eigen_GENERIC)
+target_include_directories(arch_generic PRIVATE "${CMAKE_SOURCE_DIR}/src/lib")
 if(X86)
 add_library(arch_sse4_1 OBJECT ${DISPATCH_OBJECTS})
+target_include_directories(arch_sse4_1 PRIVATE "${CMAKE_SOURCE_DIR}/src/lib")
 add_library(arch_avx2 OBJECT ${DISPATCH_OBJECTS})
+target_include_directories(arch_avx2 PRIVATE "${CMAKE_SOURCE_DIR}/src/lib")
 if (${CMAKE_CXX_COMPILER_ID} STREQUAL MSVC)
 	target_compile_options(arch_sse4_1 PUBLIC -DDISPATCH_ARCH=ARCH_SSE4_1 -DARCH_ID=1 -D__SSSE3__ -D__SSE4_1__ -D__POPCNT__ -DEigen=Eigen_SSE4_1)
     target_compile_options(arch_avx2 PUBLIC -DDISPATCH_ARCH=ARCH_AVX2 -DARCH_ID=2 /arch:AVX2 -D__SSSE3__ -D__SSE4_1__ -D__POPCNT__ -DEigen=Eigen_AVX2)
@@ -250,6 +254,7 @@
   src/stats/comp_based_stats.cpp
   src/stats/hauser_correction.cpp
   src/stats/matrix_adjust.cpp
+  src/stats/matrix_adjust_eigen.cpp
 )
 
 if(X86)
@@ -258,6 +263,19 @@
   add_executable(diamond $<TARGET_OBJECTS:arch_generic> ${OBJECTS})
 endif()
 
+list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}")
+
+target_include_directories(diamond PRIVATE
+  "${ZLIB_INCLUDE_DIR}"
+  "${CMAKE_SOURCE_DIR}/src/lib")
+
+if(EIGEN_BLAS)
+  add_definitions(-DEIGEN_USE_BLAS -DEIGEN_USE_LAPACKE)
+  find_package(LAPACKE)
+  target_include_directories(diamond PRIVATE "${LAPACKE_INCLUDE_DIR}")
+  target_link_libraries(diamond "${LAPACKE_LIBRARIES_DEP}")
+endif()
+
 target_link_libraries(diamond ${ZLIB_LIBRARY} ${CMAKE_THREAD_LIBS_INIT})
 
 install(TARGETS diamond DESTINATION bin)

=== debian/changelog ===
diamond-aligner (2.0.7-1) unstable; urgency=medium

  * Team upload.
  * New upstream version

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 15 Feb 2021 09:29:10 +0100

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Build-Depends: debhelper-compat (= 13),
                cmake,
                zlib1g-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/med-team/diamond-aligner
 Vcs-Git: https://salsa.debian.org/med-team/diamond-aligner.git
 Homepage: https://github.com/bbuchfink/diamond

=== debian/rules ===
--- 
+++ 
@@ -27,3 +27,8 @@
 
 override_dh_compress:
 	dh_compress --exclude=.pdf
+
+override_dh_auto_test:
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+	cd debian/tests && PATH=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE):$(PATH) sh diamond-calls
+endif
